/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

static int32 num_locks(struct GlobalData *gd) {
	struct ObjLock *p;
	int32 result = 0;

	p = BADDR(gd->lock_list);
	while (p) { 
		result++;
		p = BADDR(p->lock.fl_Link);
	} 

	return result; 
} 

int32 FSDeviceInfoData(struct FSVP *vp, int32 *res2, struct InfoData *id) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	uint32 num_blocks;

	IEXEC->ObtainSemaphoreShared(gd->Sem);

	id->id_NumSoftErrors = 0;
	id->id_UnitNumber    = 0;
	id->id_DiskState     = ID_DISKSTATE_WRITE_PROTECTED;

	id->id_BytesPerBlock = 1024;
	id->id_DiskType      = gd->volume_node->vn_DiskType;
	id->id_VolumeNode    = MKBADDR(gd->volume_node);
	id->id_InUse         = num_locks(gd);

	num_blocks = (gd->disk_size + 1023) >> 10;
	if (NO num_blocks) {
		num_blocks++;
	}

	id->id_NumBlocks     = num_blocks;
	id->id_NumBlocksUsed = num_blocks;

	IEXEC->ReleaseSemaphore(gd->Sem);

	*res2 = 0;
	return DOSTRUE;
}

