/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

struct Lock * FSDupLock(struct FSVP *vp, int32 *res2, struct Lock *lockin) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjLock *lock = (struct ObjLock *)lockin;
	struct Lock *result;

	IEXEC->ObtainSemaphore(gd->Sem);

	result = (struct Lock *)new_lock(gd, res2, lock->node, SHARED_LOCK);

	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

