/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

int64 FSGetFilePosition(struct FSVP *vp, int32 *res2, struct FileHandle *fh) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjLock *lock;
	int64 result = -1;

	if (fh) {
		IEXEC->ObtainSemaphoreShared(gd->Sem);

		lock = fh->fh_Arg2;

		if (lock->cache_file) {
			result = IDOS->GetFilePosition(lock->cache_file);
			if (result == -1) {
				*res2 = IDOS->IoErr();
			}
		} else {
			result = lock->current_position;
			if (result == -1) {
				*res2 = ERROR_SEEK_ERROR;
			}
		}

		IEXEC->ReleaseSemaphore(gd->Sem);
	} else {
		*res2 = ERROR_REQUIRED_ARG_MISSING;
	}

	return result;
}

