/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

int32 FSOpen(struct FSVP *vp, int32 *res2, struct FileHandle *fh,
	struct Lock *rel_lock, CONST_STRPTR name, int32 mode)
{
	struct GlobalData *gd = vp->FSV.FSPrivate;
	int32 result = DOSFALSE;
	struct ObjNode *obj;
	struct ObjLock *lock;

	IEXEC->ObtainSemaphore(gd->Sem);

	obj = handle_rel_args(gd, res2, rel_lock, name);
	if (obj) {
		if (mode == MODE_OLDFILE) {
			lock = new_lock(gd, res2, obj, SHARED_LOCK);
			if (lock) {
				fh->fh_Arg1 = MKBADDR(lock);
				fh->fh_Arg2 = lock;
				lock->fh = fh;

				result = DOSTRUE;
			}
		} else {
			*res2 = ERROR_DISK_WRITE_PROTECTED;
		}
	}

	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

