/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

int32 FSOpenFromLock(struct FSVP *vp, int32 *res2, struct FileHandle *fh, struct Lock *lockin) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjLock *lock = (struct ObjLock *)lockin;
	int32 result = DOSFALSE;
	struct ObjNode *obj;

	IEXEC->ObtainSemaphore(gd->Sem);

	if (fh && lock) {
		obj = lock->node;

		if (obj->type == FSO_TYPE_FILE) {
			fh->fh_Arg1 = MKBADDR(lock);
			fh->fh_Arg2 = lock;
			lock->fh = fh;

			result = DOSTRUE;
		} else {
			*res2 = ERROR_OBJECT_WRONG_TYPE;
		}
	} else {
		*res2 = ERROR_REQUIRED_ARG_MISSING;
	}
	
	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

