/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

struct Lock *FSParentDir(struct FSVP *vp, int32 *res2, struct Lock *lockin) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjLock *lock = (struct ObjLock *)lockin;
	struct ObjNode *obj;
	struct Lock *result = NULL;

	IEXEC->ObtainSemaphore(gd->Sem);

	if (lock) {
		if ((obj = lock->node)) {
			if ((obj = obj->parent_dir)) {
				result = (struct Lock *)new_lock(gd, res2, obj, SHARED_LOCK);
			}
		}
	}

	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

