/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

int32 FSReadSoftLink(struct FSVP *vp, int32 *res2, struct Lock *rel_lock,
	CONST_STRPTR name, STRPTR buffer, int32 bufsize)
{
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjNode *obj;
	int32 result = -1;

	IEXEC->ObtainSemaphoreShared(gd->Sem);

	obj = handle_rel_args(gd, res2, rel_lock, name);
	if (obj) {
		*res2 = ERROR_OBJECT_WRONG_TYPE;
	}

	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

