/*
** OpenAmiga.org
**  This file is part of the OpenAmiga "XAD filesystem"
**
** For more information look at:
**   http://openamiga.org/?function=viewproject&projectid=66
*/

#include "xadfs.h"

int32 FSSameLock(struct FSVP *vp, int32 *res2, struct Lock *lk1, struct Lock *lk2) {
	struct GlobalData *gd = vp->FSV.FSPrivate;
	struct ObjLock *lock1 = (struct ObjLock *)lk1;
	struct ObjLock *lock2 = (struct ObjLock *)lk2;
	int32 result = DOSFALSE;

	IEXEC->ObtainSemaphoreShared(gd->Sem);

	if (lock1 && lock2) {
		if (lock1->node == lock2->node) {
			result = DOSTRUE;
			*res2 = 0;
		}
	} else {
		*res2 = ERROR_REQUIRED_ARG_MISSING;
	}

	IEXEC->ReleaseSemaphore(gd->Sem);

	return result;
}

